
#include "cvCardBlob.h"


//-------------------------------------------------------------------
cvCardBlob::cvCardBlob(){

}

//-------------------------------------------------------------------
void    cvCardBlob::reset(){
    bSetup = false;
    bIsANumber = false;
    downwardAngle = PI/2.0f;
    bAmIUpright = false;
    bIdentifiedThisFrame = false;
    whichNum = -1;
}

//-------------------------------------------------------------------
void    cvCardBlob::setFromBlobAndImage(cvBlobAndBoundingBox & myBlob, ofxCvGrayscaleImage & myImage){

    nPts = MIN(256, myBlob.nPts);
    for (int i = 0; i < nPts; i++){
        contourPts[i].set(myBlob.pts[i].x, myBlob.pts[i].y, 0);
    }

    aspectRatio = myBlob.ratio;

    x = myBlob.centroid.x;
    y = myBlob.centroid.y;

    bool bHeightBiggerThenWidth = false;

    if (myBlob.w < myBlob.h) {
      bHeightBiggerThenWidth = true;
    }


    float centerx = myBlob.center.x;
    float centery = myBlob.center.y;
    float w = (bHeightBiggerThenWidth ? myBlob.w : myBlob.h);
    float h = (bHeightBiggerThenWidth ? myBlob.h : myBlob.w);

    angle =-(myBlob.angle*(PI/180.0f) +PI/2);

    quadPts[0].x = -w/2;
    quadPts[0].y = -h/2;
    quadPts[1].x = w/2;
    quadPts[1].y = - h/2;
    quadPts[2].x = w/2;
    quadPts[2].y = h/2;
    quadPts[3].x = -w/2;
    quadPts[3].y = h/2;

    //float minus = 0;
    for (int j = 0; j < 4; j++){
        float startAng = atan2(quadPts[j].y, quadPts[j].x);
        //if (j == 0) minus = startAng;
        float length = sqrt(quadPts[j].y * quadPts[j].y + quadPts[j].x * quadPts[j].x);
        startAng += angle;
        quadPts[j].x = centerx + length * cos(startAng + PI + (bHeightBiggerThenWidth ? 0 : -PI/2));;
        quadPts[j].y = centery + length * sin(startAng + PI + (bHeightBiggerThenWidth ? 0 : -PI/2));;
    }
    bSetup = true;


     if (bHeightBiggerThenWidth) angle += PI/2.0f;

     angle += PI;


    // ---- uprightness stuff ---- be an upright citizen !
    midPt.set(0,0);
    for (int i = 0; i < 4; i++){
        midPt.x += quadPts[i].x;
        midPt.y += quadPts[i].y;
    }
    midPt.x /= 4.0f;
    midPt.y /= 4.0f;




}

//-------------------------------------------------------------------
void cvCardBlob::draw(){

    ofxVec2f midPt; midPt.set(0,0);

    ofBeginShape();
    for (int i = 0; i < 4; i++){
        ofVertex(quadPts[i].x, quadPts[i].y);
        midPt.x += quadPts[i].x;
        midPt.y += quadPts[i].y;
    }
    ofEndShape(true);

    midPt.x /= 4.0f;
    midPt.y /= 4.0f;

    if (bIsANumber){
      ofDrawBitmapString( ofToString(whichNum+1),  quadPts[0].x, quadPts[0].y);
      ofLine (midPt.x, midPt.y, midPt.x + 25 * cos(angle - (PI/2.0f - downwardAngle)), midPt.y + 25 * sin( angle -  (PI/2.0f - downwardAngle)));
    }
}

