#include "cvCardContourFinder.h"

CvMoments				*myMomentsTemp;


//--------------------------------------------------------------------------
cvCardContourFinder::cvCardContourFinder(){

	myMoments 		= (CvMoments*) malloc(sizeof(CvMoments));
	myMomentsTemp 	= (CvMoments*) malloc(sizeof(CvMoments));
	blobs			= new cvBlobAndBoundingBox[MAX_NUM_CONTOURS_TO_FIND];
	reset();



    normalizedBlob.allocate(60,60);

}

//--------------------------------------------------------------------------
void cvCardContourFinder::reset(){
	nBlobs = 0;
	//memset(blobs, 0, sizeof(cvBlobAndBoundingBox) * MAX_NUM_CONTOURS_TO_FIND);
}

//--------------------------------------------------------------------------
void cvCardContourFinder::draw(){



	ofSetColor(66,66,66 );
	for (int i = 0; i < nBlobs; i++){
		glPushMatrix();
		glTranslatef(blobs[i].center.x, blobs[i].center.y, 0);

		//float angle =-(ofCvF.blobs[i].angle+PI/2);

		//glRotatef( (-(blobs[i].angle)) * (180.0f / PI),0,0,1);
		// ofRect(-blobs[i].w/2, -blobs[i].h/2, blobs[i].w, blobs[i].h);
		glPopMatrix();

		char temp[255];

		float ratio = 1;
		if (blobs[i].w > blobs[i].h) ratio = blobs[i].w / blobs[i].h;
		else ratio = blobs[i].h / blobs[i].w;
		sprintf(temp, "%0.2f\n", blobs[i].angle);
		ofDrawBitmapString(temp, blobs[i].center.x + 20, blobs[i].center.y);
	}




	ofEnableAlphaBlending();
	ofSetColor(255,127,0,50);
	ofNoFill();
	for (int i = 0; i < nBlobs; i++){
		float area =  blobs[i].w * blobs[i].h;

		float ratio = 1;
		if (blobs[i].w > blobs[i].h) ratio = blobs[i].w / blobs[i].h;
		else ratio = blobs[i].h / blobs[i].w;

		//if (area > 150 && area < 900 && ratio > 1.1){
		ofRect(blobs[i].boundingRect.x, blobs[i].boundingRect.y, blobs[i].boundingRect.width, blobs[i].boundingRect.height);
		//}
	}
	ofDisableAlphaBlending();

	ofSetColor(0xffffff);
	for (int i = 0; i < nBlobs; i++){
		float area =  blobs[i].w * blobs[i].h;
		float ratio = 1;
		if (blobs[i].w > blobs[i].h) ratio = blobs[i].w / blobs[i].h;
		else ratio = blobs[i].h / blobs[i].w;


		//if (area > 150 && area < 900  && ratio > 1.1){
			glBegin(GL_LINE_LOOP);
			for (int j = 0; j < blobs[i].nPts; j++){
				glVertex2f(blobs[i].pts[j].x, blobs[i].pts[j].y);
			}
			glEnd();
		//}
	}



    ofSetColor(0,255,255);
	ofPoint src[4];

	for (int i = 0; i < nBlobs; i++){

			float area =  blobs[i].w * blobs[i].h;
			float ratio = 1;
			if (blobs[i].w > blobs[i].h) ratio = blobs[i].w / blobs[i].h;
			else ratio = blobs[i].h / blobs[i].w;



					float centerx = blobs[i].center.x;
					float centery = blobs[i].center.y;
					float w = blobs[i].w;
					float h = blobs[i].h;

					float angle = (-blobs[i].angle + 90) * (PI/180.0f) ;//(-blobs[i].angle+PI/2);

					src[0].x = -w/2;
					src[0].y = -h/2;
					src[1].x = w/2;
					src[1].y = - h/2;
					src[2].x = w/2;
					src[2].y = h/2;
					src[3].x = -w/2;
					src[3].y = h/2;

					for (int i = 0; i < 4; i++){
						float startAng = atan2(src[i].y, src[i].x);
						float length = sqrt(src[i].y * src[i].y + src[i].x * src[i].x);
						startAng += angle;
						src[i].x = centerx + length * cos(startAng);
						src[i].y = centery + length * sin(startAng);
					}

				ofBeginShape();
					for (int i = 0; i < 4; i++) ofVertex(src[i].x, src[i].y);
				ofEndShape(true);




		}

    normalizedBlob.draw(0,0);

}


static int qsort_carea_compare ( const void* _a, const void* _b) {
	int out = 0;
	// pointers, ugh.... sorry about this
	CvSeq* a = *((CvSeq **)_a);
	CvSeq* b = *((CvSeq **)_b);
	// use opencv to calc size, then sort based on size
	float areaa = fabs(cvContourArea(a, CV_WHOLE_SEQ));
	float areab = fabs(cvContourArea(b, CV_WHOLE_SEQ));


	cvMoments(a, myMomentsTemp);
	float ax = (myMomentsTemp->m10 / myMomentsTemp->m00);
	cvMoments(b, myMomentsTemp);
	float bx = (myMomentsTemp->m10 / myMomentsTemp->m00);

	// note, based on the -1 / 1 flip
	// we sort biggest to smallest, not smallest to biggest
	if (ax < bx) { out = -1; }
	else {               out =  1; }
	return out;
}


//--------------------------------------------------------------------------
void cvCardContourFinder::findContours (		ofxCvGrayscaleImage &	input,
											int 				    minArea,
											int 				    maxArea,
											int 				    nConsidered,
											bool 				    bFindHoles){


	// opencv will clober the image it detects contours on, so we want to copy it
	// into a copy before we detect contours.  That copy is allocated if necessary
	// (necessary = (a) not allocated or (b) wrong size)
	// so be careful if you pass in different sized images to "findContours"
	// there is a performance penalty, but we think there is not a memory leak to worry about
	// better to create mutiple contour finders for different sizes, ie,
	// if you are finding contours in a 640x480 image but also a 320x240 image
	// better to make two cvCardContourFinder objects then to use one, because
	// you will get penalized less.

	if (inputCopy.width == 0){
		inputCopy.allocate(input.width, input.height);
		inputCopy = input;
	} else {
		if (inputCopy.width == input.width && inputCopy.height == input.height){
			inputCopy = input;
		} else {
			// we are allocated, but to the wrong size --
			// been checked for memory leaks, but a warning:
			// be careful if you call this function with alot of different
			// sized "input" images!, it does allocation every time
			// a new size is passed in....
			inputCopy.clear();
			inputCopy.allocate(input.width, input.height);
			inputCopy = input;
		}
	}


	CvSeq* contour_list 				= NULL;
	contour_storage 					= cvCreateMemStorage(1000);
	storage 							= cvCreateMemStorage(1000);

	CvContourRetrievalMode retrieve_mode = (bFindHoles) ? CV_RETR_LIST : CV_RETR_EXTERNAL;
	cvFindContours (inputCopy.getCvImage(), contour_storage, &contour_list, sizeof(CvContour), retrieve_mode,  CV_CHAIN_APPROX_NONE);
	CvSeq* contour_ptr = contour_list;

	nCvSeqsFound = 0;
	//-------------------------------------
	// put the contours from the linked list, into an array for sorting
	while ((contour_ptr != NULL)){

		float area = fabs(cvContourArea(contour_ptr, CV_WHOLE_SEQ));

		if ((area > minArea) && (area < maxArea)) {
				if (nCvSeqsFound < MAX_NUM_CONTOURS_TO_FIND){
					cvSeqBlobs[nCvSeqsFound] = contour_ptr;		// copy the pointer
					nCvSeqsFound++;
				}
		}

		contour_ptr = contour_ptr->h_next;
	}
	//------------------------------------- sort the pointers based on size...
	if (nCvSeqsFound > 0){
		qsort( cvSeqBlobs, nCvSeqsFound, sizeof(CvSeq*), qsort_carea_compare);
	}

	// now, we have nCvSeqsFound contours, sorted by size in the array cvSeqBlobs
	// let's get the data out and into our structures that we like....

	nBlobs = MIN(nConsidered, nCvSeqsFound);		// take the minumum!

	for (int i = 0; i < nBlobs; i++){

		float area 			= cvContourArea(cvSeqBlobs[i], CV_WHOLE_SEQ);
		CvRect rect 		= cvBoundingRect(cvSeqBlobs[i], 0);
		cvMoments(cvSeqBlobs[i], myMoments);

		blobs[i].area 					= fabs(area);
		blobs[i].hole 					= area < 0 ? true : false;
		blobs[i].length 				= cvArcLength(cvSeqBlobs[i]);
		blobs[i].boundingRect.x 		= rect.x;
		blobs[i].boundingRect.y 		= rect.y;
		blobs[i].boundingRect.width 	= rect.width;
		blobs[i].boundingRect.height	= rect.height;
		blobs[i].centroid.x 			= (int) (myMoments->m10 / myMoments->m00);
		blobs[i].centroid.y 			= (int) (myMoments->m01 / myMoments->m00);

		// get the points for the blob:
		blobs[i].nPts 					= MIN(MAX_CONTOUR_LENGTH, cvSeqBlobs[i]->total);

		CvPoint pt;
		CvSeqReader reader;
		cvStartReadSeq (cvSeqBlobs[i], &reader, 0);

		for (int j=0; j < blobs[i].nPts; j++){
			CV_READ_SEQ_ELEM(pt, reader);
			blobs[i].pts[j].x = (float)pt.x;
			blobs[i].pts[j].y = (float)pt.y;
		}


		CvBox2D box = cvMinAreaRect2(cvSeqBlobs[i], NULL );
		blobs[i].center.x = box.center.x;
		blobs[i].center.y = box.center.y;
		blobs[i].w = box.size.width;
		blobs[i].h = box.size.height;
		blobs[i].angle = box.angle;
		blobs[i].boxArea = blobs[i].w  * blobs[i].h;

		if (blobs[i].w > blobs[i].h){
		    blobs[i].ratio = blobs[i].w / blobs[i].h;
		} else {
			blobs[i].ratio = blobs[i].h / blobs[i].w;
		}


        //computeBlackness(blobs + i, input);
	}
	//-----------------------------------------------------
	// Free the storage memory.
	// Warning: do this inside this function otherwise you get a strange memory leak
	if (contour_storage != NULL) 	{ cvReleaseMemStorage(&contour_storage);}
	if (storage != NULL) 	{ cvReleaseMemStorage(&storage);}

}

/*
// not entirely sure if this is helpful.  :(
// could be uselful for getting
// suits, or suit from cards.
 void cvCardContourFinder::computeBlackness(cardBlob * blob, ofxCvGrayscaleImage &	input){

		ofPoint src[4];
        ofPoint dst[4];
		dst[0].x = 0;
		dst[0].y = 0;
		dst[1].x = 60;
		dst[1].y = 0;
		dst[2].x = 60;
		dst[2].y = 60;
		dst[3].x = 0;
		dst[3].y = 60;

        float area =  blob->w * blob->h;
        float ratio = 1;
        if (blob->w > blob->h) ratio = blob->w / blob->h;
        else ratio = blob->h / blob->w;
        if (area > minArea && area < maxArea  && ratio > minRatio){



                float centerx = blob->center.x;
                float centery = blob->center.y;
                float w = blob->w;
                float h = blob->h;

                float angle = (-blob->angle + 90) * (PI/180.0f) ;//(-blob->angle+PI/2);

                src[0].x = -w/2;
                src[0].y = -h/2;
                src[1].x = w/2;
                src[1].y = - h/2;
                src[2].x = w/2;
                src[2].y = h/2;
                src[3].x = -w/2;
                src[3].y = h/2;

                for (int i = 0; i < 4; i++){
                    float startAng = atan2(src[i].y, src[i].x);
                    float length = sqrt(src[i].y * src[i].y + src[i].x * src[i].x);
                    startAng += angle;
                    src[i].x = centerx + length * cos(startAng);
                    src[i].y = centery + length * sin(startAng);
                }

        //printf("%i \n", normalizedBlob.width);
        normalizedBlob.warpIntoMe(input, src, dst);
        //normalizedBlob.contrastStretch();
        normalizedBlob.threshold(128);
        int nWhite = normalizedBlob.countNonZeroInRegion(0,0,60,60);
        blob->pctPixelsBlack = (float)(3600 - nWhite) / (3600.0f);
        } else {
        blob->pctPixelsBlack = -1;
        }
 }
*/
