#ifndef _CARD_CONTOUR_FINDER
#define _CARD_CONTOUR_FINDER


#include "ofMain.h"

#include "ofMain.h"

#define OF_ADDON_USING_OFXOPENCV
#define OF_ADDON_USING_OFXVECTORMATH

#include "ofAddons.h"


// I am like the contour finder, but different.
// I do different things :)


#define MAX_CONTOUR_LENGTH 1024
//#define MAX_NUM_CONTOURS_TO_FIND 256


//------------------------------
typedef struct {
	float				area;			// area of contour
	float				length;			// length of contour
	ofRectangle			boundingRect;	// bounding box
	ofxPoint2f			centroid;		// centroid
	bool				hole;			// am I a hole?
	int					nPts;
	ofxPoint2f			pts[MAX_CONTOUR_LENGTH];

	// zach's hack :
	ofxPoint2f center;       // center of the box.
   	float w, h;             // box width and length
    float angle;            // angle between the horizonal axis and the first side (i.e length) in radians

    float   ratio;
    float   boxArea;


} cvBlobAndBoundingBox;


//--------------------------------------------------------------------
class cvCardContourFinder {

	public:

		cvCardContourFinder();

		void  		findContours (		ofxCvGrayscaleImage	& 	input,
										int 					minArea,
										int 					maxArea,
										int 					nConsidered,
										bool 					bFindHoles);

		void 		reset();
		void 		draw();

        //void        computeBlackness(cardBlob * blob, ofxCvGrayscaleImage &	input);

		ofxCvGrayscaleImage		inputCopy;
		CvMemStorage			*contour_storage;
		CvMemStorage			*storage;
		CvMoments				*myMoments;


		// --------------------------------
		// all coin specific stuff.
		// also, white, non white would be AWESOMELY helpful.  I guess that'll have to wait until I pop these guys into
		// images?  should I put them in images?

		ofxCvGrayscaleImage     normalizedBlob;

		// --------------------------------

		//----------------------------------- an array of cvSequences
		int 					nCvSeqsFound;
		CvSeq* 					cvSeqBlobs[MAX_NUM_CONTOURS_TO_FIND];

		int 					    nBlobs;
		cvBlobAndBoundingBox		* blobs;



};

#endif
