#ifndef _CARD_FEATURE_FINDER
#define _CARD_FEATURE_FINDER


#include "ofMain.h"

#define OF_ADDON_USING_OFXOPENCV
#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXXMLSETTINGS

#include "ofAddons.h"

#include "cvCardContourFinder.h"
#include "cvCardBlob.h"
#include "cvCardSeperator.h"
#include "cvNumberLearner.h"

class cvManager {

	public:

		cvManager();

        void setup();
        void update(ofxCvColorImage & video);
        void draw();

        void saveSettings();
        void loadSettings();


        //--------------------------------------- learning related
        void learnNumbers(int numberset);
        ofxCvGrayscaleImage *    numberTemplate;            // sorry for being a pointer, but easier to pass into a vector
        cvNumberLearner         NL;

        //--------------------------------------- input and processing
		ofxCvColorImage 			cvInputColor;
		ofxCvGrayscaleImage 		cvInputGray;
        cvCardSeperator             CS;
        cvCardContourFinder		    ofCvF;

		int w;
		int h;

        //--------------------------------------- feedback
		ofTrueTypeFont              font;
		int                         drawMode;

        //--------------------------------------- output
		ofImage                     outputter;
		bool                        saveSnapshot;
		int                         snapshotCounter;

        //--------------------------------------- settings
        ofxXmlSettings              settings;
        float                       minArea;
		float                       maxArea;
		float                       minRatio;

        cvCardBlob                  numbers[128];
        int                         nNumbers;
        cvNumberComparer            NC;
        ofxCvGrayscaleImage         * blobAsTempate;



};

#endif
