
#include "cvNumberIdentifier.h"

//--------------------------------------------------------------------------
cvNumberIdentifier::cvNumberIdentifier(){

	numbers.loadImage("images/numbers.jpg");
	numbers.setImageType(OF_IMAGE_GRAYSCALE);

	cvInputGray.allocate(numbers.width, numbers.height);
	cvInputGrayNonThresh.allocate(numbers.width, numbers.height);
	w = numbers.width;
	h = numbers.height;

    nImagesTemplate = 0;
	for (int i = 0; i < MAX_NUMS_TO_CHECK; i++){
		numbersWarpedTemplate[i].allocate(60,60);
	}

	findNumberImages();

}

//--------------------------------------------------------------------------
void cvNumberIdentifier::draw(){

    numbers.draw(0,0);
    for (int i = 0; i < nImagesTemplate; i++){
        numbersWarpedTemplate[i].draw(i*60,0,60,60);
    }

    ofCvF.draw();
}

//--------------------------------------------------------------------------
void cvNumberIdentifier::findNumberImages(){

	cvInputGray.setFromPixels(numbers.getPixels(),w,h);
	cvInputGrayNonThresh = cvInputGray;
	cvInputGray.threshold(244);
	cvInputGray.invert();

	ofCvF.findContours(cvInputGray, 40,1000,70,true);


	//-----------------------------------------------------

	nImagesTemplate = 0;

	ofPoint src[4];
	ofPoint dst[4];

	dst[0].x = 0;
	dst[0].y = 0;
	dst[1].x = 60;
	dst[1].y = 0;
	dst[2].x = 60;
	dst[2].y = 60;
	dst[3].x = 0;
	dst[3].y = 60;

	for (int i = 0; i < ofCvF.nBlobs; i++){

		float area =  ofCvF.blobs[i].w * ofCvF.blobs[i].h;
		float ratio = 1;

		bool bHeightBiggerThenWidth = false;

		if (ofCvF.blobs[i].w > ofCvF.blobs[i].h) ratio = ofCvF.blobs[i].w / ofCvF.blobs[i].h;
		else {
			bHeightBiggerThenWidth = true;
			ratio = ofCvF.blobs[i].h / ofCvF.blobs[i].w;
		}

		if (area > 250 && area < 600  && ratio > 1.1){

			if (nImagesTemplate < MAX_NUMS_TO_CHECK){

				float centerx = ofCvF.blobs[i].center.x;
				float centery = ofCvF.blobs[i].center.y;
				float w = (bHeightBiggerThenWidth ? ofCvF.blobs[i].w : ofCvF.blobs[i].h);
				float h = (bHeightBiggerThenWidth ? ofCvF.blobs[i].h : ofCvF.blobs[i].w);

				float angle =-(ofCvF.blobs[i].angle*(PI/180.0f) +PI/2);

				src[0].x = -w/2;
				src[0].y = -h/2;
				src[1].x = w/2;
				src[1].y = - h/2;
				src[2].x = w/2;
				src[2].y = h/2;
				src[3].x = -w/2;
				src[3].y = h/2;

				float minus = 0;
				for (int j = 0; j < 4; j++){
					float startAng = atan2(src[j].y, src[j].x);
					if (j == 0) minus = startAng;
					float length = sqrt(src[j].y * src[j].y + src[j].x * src[j].x);
					startAng += angle;

					src[j].x = centerx + length * cos(startAng + PI + (bHeightBiggerThenWidth ? 0 : -PI/2));;
					src[j].y = centery + length * sin(startAng + PI + (bHeightBiggerThenWidth ? 0 : -PI/2));;
				}
				numbersWarpedTemplate[nImagesTemplate].warpIntoMe(cvInputGrayNonThresh, src, dst);
				//numbersWarpedTemplate[nImagesTemplate].contrastStretch();
				//numbersWarpedTemplate[nImagesTemplate].invert();
				//numbersWarpedTemplate[nImagesTemplate].threshold(128);
				nImagesTemplate++;
			}
		}
	}
}
