#include "cvNumberLearner.h"

cvNumberLearner::cvNumberLearner(){
    //ctor
    nAngleManipulating = 0;
}

cvNumberLearner::~cvNumberLearner(){
    //dtor
}

//-----------------------------------------------------------------------------------------------------
void cvNumberLearner::alterAngle(int nToAddToManip, float amountToAlter){

    int nImgAllTogether = 0;
    for (int i = 0; i < 13; i++){
         nImgAllTogether += numbers[i].downwardAngles.size();
    }

    if (nToAddToManip != 0){
            nAngleManipulating += nToAddToManip;
            while (nAngleManipulating > nImgAllTogether) nAngleManipulating -= nImgAllTogether;
            while (nAngleManipulating < 0) nAngleManipulating += nImgAllTogether;
    }

    int count = 0;
    for (int i = 0; i < 13; i++){
        for (int j = 0; j < numbers[i].downwardAngles.size(); j++){
            if (count == nAngleManipulating){
                numbers[i].downwardAngles[j] += amountToAlter;
            }
            count++;
        }
    }
}

//-----------------------------------------------------------------------------------------------------
void cvNumberLearner::learnThisNumber(int numberToLearn, ofxCvGrayscaleImage * templateImage){
    // now, check if different enough
    bool bSimilarToAnyone = false;
    for (int i = 0; i < numbers[numberToLearn].images.size(); i++){
        float diff = NC.totalDifference(templateImage, numbers[numberToLearn].images[i]);
        if (diff < 40 ){
            bSimilarToAnyone = true;
        }
    }
    if (!bSimilarToAnyone) numbers[numberToLearn].addNumber(templateImage);
}

void cvNumberLearner::saveNumbers(){




    unsigned char pixm[64*64*3];


    for (int i = 0; i < 13; i++){
        ofxXmlSettings settings;
        settings.setVerbose(true);
        settings.loadFile("someFileThatDoesntExist.xml");
        int nImgs = numbers[i].images.size();
        settings.loadFile("someFileThatDoesntExist.xml");
        settings.setValue("param:numImages", nImgs);

        for (int j = 0; j < numbers[i].downwardAngles.size(); j++){
            settings.addValue("angle", numbers[i].downwardAngles[j]);
        }
        //numbers[i].downwardAngles.push_back(PI / 2.0f);


        string fileName = "learner/num_" + ofToString(i) + "_settings.xml";
        //cout << fileName;
        settings.saveFile(fileName);

        for (int j = 0; j < nImgs; j++){
            unsigned char * pixels =  numbers[i].images[j]->getPixels();
            for (int k = 0; k< 64*64*3; k++){
                pixm[k] = pixels[k/3];
            }
            ofImage temp;
            temp.allocate(64, 64, OF_IMAGE_GRAYSCALE);
            string imageName = "learner/img_num" + ofToString(i) + "." + ofToString(j) + ".jpg";
            temp.setFromPixels(pixm, 64, 64, OF_IMAGE_COLOR);
            //temp.setImageType(OF_IMAGE_GRAYSCALE);
            temp.saveImage(imageName);
        }

    }
}

void cvNumberLearner::loadNumbers(){

    for (int i = 0; i < 13; i++){
        ofxXmlSettings settings;
        settings.setVerbose(true);
        string fileName = "learner/num_" + ofToString(i) + "_settings.xml";
        settings.loadFile(fileName);
        int nImgs = settings.getValue("param:numImages", 0);
        //printf("numImages = %i \n", nImgs);

        for (int j = 0; j < nImgs; j++){
            float angle = settings.getValue("angle", PI/2.0f, j);
            ofImage temp;
            string imageName = "learner/img_num" + ofToString(i) + "." + ofToString(j) + ".jpg";
            temp.loadImage(imageName);
            temp.setImageType(OF_IMAGE_GRAYSCALE);
            ofxCvGrayscaleImage * numberTemplate = new ofxCvGrayscaleImage();
            numberTemplate->allocate(64, 64);
            numberTemplate->setFromPixels(temp.getPixels(), 64, 64);
            numbers[i].images.push_back(numberTemplate);
	        numbers[i].downwardAngles.push_back(angle);

        }
    }
}
