#ifndef NUMBERLEARNER_H
#define NUMBERLEARNER_H

#include "ofMain.h"

#define OF_ADDON_USING_OFXOPENCV
#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXXMLSETTINGS

#include "ofAddons.h"
#include "cvNumberComparer.h"

//---------------------------------------------------------------------
class numberTemplateSet {

public:

    vector <ofxCvGrayscaleImage *> images;
    vector <float> downwardAngles;

    void addNumber(ofxCvGrayscaleImage * num ) {
        images.push_back(num);
        downwardAngles.push_back(PI / 2.0f);
    }

    void draw(float x, float y) {
        glPushMatrix();
        glTranslatef(x,y,0);
        for (int i = 0; i< images.size(); i++) {
            images[i]->draw(0,0);
            if (downwardAngles.size() > 0){
                ofLine (32,32, 32 + 20 * cos(downwardAngles[i]), 32 + 20 * sin(downwardAngles[i]));
            }
            glTranslatef(images[i]->width, 0, 0);
        }



        glPopMatrix();


    }



};


class cvNumberLearner {
public:
    cvNumberLearner();
    virtual ~cvNumberLearner();

    void learnThisNumber(int numberToLearn, ofxCvGrayscaleImage * templateImage);
    void cvNumberLearner::saveNumbers();
    void cvNumberLearner::loadNumbers();

    cvNumberComparer        NC;
    numberTemplateSet       numbers[13];

    int                     nAngleManipulating;
    void                    alterAngle(int nToAddToManip, float amountToAlter);


    void draw(){ for (int i = 0; i < 13; i++) numbers[i].draw(0,64*i); };



protected:
private:
};

#endif // NUMBERLEARNER_H
