#include "testApp.h"
#include "stdio.h"

//--------------------------------------------------------------
testApp::testApp(){

}

//--------------------------------------------------------------
void testApp::setup(){
	ofBackground(255,255,255);

	bUseVideo = true;

	if (bUseVideo){
		fallout.loadMovie("movies/cardsTest.avi");
		fallout.play();
		fallout.setSpeed(0.99f);
		w = fallout.width;
		h = fallout.height;
	} else {
		grabber.initGrabber(640,480);
		w = grabber.width;
		h = grabber.height;

	}

    for (int i = 0; i < 13; i++){
        string fileName = "";
        fileName += "images/screen" + ofToString(i) + ".jpg";
        numbers[i].loadImage(fileName);
    }


    inputAsCv.allocate(w,h);
    snapshotCounter = 0;

    CFF.setup();
    numTraining = 0;
    //MP.setupMidi(0);

    scanhead = 0;
    scanheadSpeed = 5;
    bDrawDiagnostic = true;
	CFF.drawMode = 1;
	
    lastUpdateTime = ofGetElapsedTimef();
}


//--------------------------------------------------------------
void testApp::update(){

    float timeNow = ofGetElapsedTimef();
    float diffTime = timeNow - lastUpdateTime;
    lastUpdateTime = timeNow;


	ofBackground(0,0,0);

	bool bIsNew = false;
	if (bUseVideo){
		fallout.idleMovie();
		bIsNew = fallout.isFrameNew();
	} else {
		grabber.grabFrame();
		bIsNew = grabber.isFrameNew();
	}

	if (true){
        if (bUseVideo){
			inputAsCv.setFromPixels(fallout.getPixels(), w, h);
		} else {
			inputAsCv.setFromPixels(grabber.getPixels(), w, h);
		}
        CFF.update(inputAsCv);
        TM.checkCardBlobs(CFF.numbers, CFF.nNumbers);
        TM.update();
        //int                         nNumbers;
	}

	//MP.update();


    // find min max AND the closest ONE
    float maxVal = 0;
    float minVal = 640;
    float closestDist = 10000000;
    int closestOne = -1;

    for (int i = 0; i < TM.trackers.size(); i++){
        float x = TM.trackers[i]->x;
        if (x < minVal) minVal = x;
        if (x > maxVal) maxVal = x;
        float dist = fabs(scanhead - TM.trackers[i]->x);
        if ( dist < closestDist ){
             closestDist = dist;
             closestOne = i;
        }
    }

   scanheadSpeed = 4 + ((float)mouseY / 768.0f) * 120;

    /*
    if (closestOne != -1){
        float yPct = 1 - (TM.trackers[closestOne]->y / 480.0f);
        scanheadSpeed = 0.92f * scanheadSpeed + 0.08f * (1 + (yPct * 30));
    }  else {
        scanheadSpeed = 0.92f * scanheadSpeed + 0.08f * (1);
    }
    */
    float prevScanHead = scanhead;
	scanhead += diffTime * (400 + 3000 * ((float)mouseY / 768.0f));
	//scanheadSpeed;
	for (int i = 0; i < TM.trackers.size(); i++){
	    float x = TM.trackers[i]->x;
	    float y = TM.trackers[i]->y;
        float yNormalized = (y / 480.0f) * 80 + 40;
	    float energy = TM.trackers[i]->energy;
	    int num = TM.trackers[i]->num;
	    if (x > prevScanHead && x <= scanhead){
	        if (energy > 0.85f){
                //MP.setInstrument(0,num);
                //MP.noteOnForDuration(0,(int)yNormalized,80,0.6);
                if (TM.trackers[i]->num == 0 ||
                    TM.trackers[i]->num >= 10){
                        //MP.percussiveNoteOn((int)yNormalized, 80);
                    } else {

                        printf("--------------------------------%f \n", TM.trackers[i]->angle / PI);
                        int noteChange = (int)((TM.trackers[i]->angle / PI) * 6);

                        float pctY = 1 - (TM.trackers[i]->y / 480.0f);
                        //MP.noteOnForDuration(0,40 + TM.trackers[i]->num * 2 + noteChange,(int)(pctY * 127),0.6);
                    }
                visualOutput * VO = new visualOutput();
                ofPoint temp;
                temp.x = TM.trackers[i]->x;
                temp.y = TM.trackers[i]->y;
                VO->start(temp);
                circles.push_back(VO);
	        }
	    }
	}


	if (scanhead > maxVal + 100){
	 scanhead = minVal-100;
	}

/*
    if (scanhead > 640){
	 scanhead = 0;
	}
*/


	std::vector <visualOutput *>::iterator it;
    for(it = circles.begin(); it != circles.end();){
      if((*it)->energy < 0.05){
        it = circles.erase(it);
      }else
        ++it;
    }


 for (int i = 0; i < circles.size(); i++) {
        circles[i]->update();
    }




}

//--------------------------------------------------------------
void testApp::draw(){

    if (bDrawDiagnostic == true){
        //cout<< ofGetFrameRate() << endl;
        CFF.draw();
        TM.draw();
        //ofLine(scanhead, 0, scanhead, 480);
    } else {
        inputAsCv.draw(0,0,1024,768);
        glScalef(1024/640.0f, 768.0/480.0f,1);
        for (int i = 0; i < circles.size(); i++) {
            circles[i]->draw();
        }
    }

}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){
	switch(key){

		case 'a':
			CFF.CS.nonCardTheshold--;
			break;
		case 's':
            CFF.CS.nonCardTheshold++;
			break;
        case 'z':
            CFF.CS.bgSubTheshold--;
            break;
        case 'x':
            CFF.CS.bgSubTheshold++;
            break;
		case 'r':
			if (bUseVideo){
                float pct = (float)mouseX / (float)ofGetWidth();
                fallout.setSpeed(pct);
			}
			break;
		case 't':
			//myTracker.findNextNumber();
			break;
        case ' ':
            CFF.drawMode++;
            CFF.drawMode %= 3;
            break;
        case 'd':
            CFF.minArea++;
            break;
        case 'c':
            CFF.minArea--;
            break;
         case 'f':
            CFF.maxArea++;
            break;
        case 'v':
            CFF.maxArea--;
            break;
        case 'g':
            CFF.minRatio+=0.01f;
            break;
        case 'b':
            CFF.minRatio-=0.01f;
            break;
        case 'S':
            CFF.saveSettings();
            break;
        case 'X':
            saveSnapshot = true;
            break;
        case 'L':
            CFF.learnNumbers(numTraining);
            break;
        case 'N':
            CFF.NL.saveNumbers();
            break;
        case 'n':
            numTraining++;
            numTraining %= 13;
            return;
        case 'o':
            CFF.NL.alterAngle(1,0);
            break;
        case 'p':
            CFF.NL.alterAngle(0,0.1);
            break;
        case '1':
            bDrawDiagnostic = !bDrawDiagnostic;
            break;

	}
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	if (bUseVideo){
        float pct = (float)mouseX / (float)ofGetWidth();
        fallout.setSpeed(0);
        fallout.setPosition(pct);
	}
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
    //MP.noteOnForDuration(0,100,127,5);
}

//--------------------------------------------------------------
void testApp::mouseReleased(){

}



