#ifndef _TEST_APP
#define _TEST_APP


#include "ofMain.h"

#define OF_ADDON_USING_OFXOPENCV
#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXXMLSETTINGS

#include "ofAddons.h"

#include "cvManager.h"
#include "trackerManager.h"
//#include "midiPlayer.h"



class visualOutput {

        public:

            ofPoint pos;

            float innerRadius;
            float outerRadius;
            float energy;

            void start(ofPoint pt){
              pos.x = pt.x;
              pos.y = pt.y;
              energy = 1;
              outerRadius = 30;
            }
            void update(){
              energy *= 0.93f;
              outerRadius += 3.0f;
            }
            void draw( ){
                //printf("here \n");
                ofEnableAlphaBlending();
                ofSetColor(255,200,200, (int)(energy * 140));
                ofFill();
                ofBeginShape();
                for (int i = 0; i < 30; i++){
                  float angle = (float)i/29.0f;
                  ofVertex(pos.x + cos(angle*TWO_PI) * outerRadius, pos.y + sin(angle*TWO_PI) * outerRadius);
                }
                ofEndShape(true);
                ofDisableAlphaBlending();
                ofSetColor(0xffffff);
            }

};



class testApp : public ofSimpleApp{

	public:

		testApp();
		void setup();
		void update();
		void draw();

		void keyPressed  (int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased();

        void saveSettings();
        void loadSettings();
        ofxXmlSettings settings;

		void findNumberImages();

		ofVideoPlayer 			fallout;
		ofVideoGrabber			grabber;
		bool 					bUseVideo;

		int w;
		int h;


        cvManager                   CFF;
        trackerManager              TM;

        //midiPlayer                  MP;


        ofxCvColorImage             inputAsCv;

		ofImage                     outputter;
		bool                        saveSnapshot;
		int                         snapshotCounter;

		ofImage                     numbers[13];
		int                         numTraining;


		float                       scanhead;
		float                       scanheadSpeed;

		std::vector <visualOutput *> circles;

		bool                        bDrawDiagnostic;
		float                       lastUpdateTime;



};

#endif
